function adeiBusy(msg, module_name, module) {
    
}

function adeiGetErrorMessage(msg, module_name, module) {
    if (typeof module_name == "undefined")
	return msg;
    else
	return "Error in '" + module_name + "': " + msg;
}

function adeiReportError(msg, module_name, module) {
    alert(adeiGetErrorMessage(msg, module_name, module));
}

function adeiGetExceptionMessage(e, msg) {
    var emsg;
    if (msg) emsg = msg + ", " + translate("error: ");
    else emsg = translate("Exception caught, error: ");

    if (e.description) emsg += e.description;
    else if (e.message) emsg += e.message;
    else emsg += translate("Unknown error");
    
    if (e.fileName) {
	emsg += "(" + e.fileName;
	if (e.lineNumber) emsg += ":" + e.lineNumber;
	emsg += ")";
    }
    
    if (e.stack) {
	emsg += "\n\n" + e.stack;
    }
    
    return emsg;
}

function adeiReportException(e, msg, module_name, module) {
    var emsg = adeiGetExceptionMessage(e, msg);
    adeiReportError(emsg, module_name, module);
}


function adeiReplaceProp(props, prop, value) {
    /* To be implemented */
}

function objectClone(obj, skip) {
    if (typeof skip == "undefined") skip = new Array();
    
    var res = new Object;
    for (var i in obj) {
	if ((obj[i])&&(typeof obj[i] == "object")&&(skip.indexOf(i)<0))
	    res[i] = objectClone(obj[i]);
	else	    
	    res[i] = obj[i];
    }
    return res;
}

function urlConcatenate(base, extra) {
    if (extra) {
	if (/\?/.exec(base)) return base + "&" + extra;
	else return base + "?" + extra;
    }
    return base;
}

function urlAddProperty(base, name, value) {
    if (/\?/.exec(base)) return base + "&" + name + "=" + value;
    else return base + "?" + name + "=" + value;
}

function adeiDateFormat(d, range) {
    var mydate = new Date(Math.floor(d)*1000);
    if ((range)&&(range <= adei.cfg.subsecond_threshold)) {
	var ds = d.toString();
	var subsecs = ds.indexOf('.');
	if (subsecs >= 0) return dateFormat(mydate) + '.' + ds.substr(subsecs + 1);
	else return dateFormat(mydate);
    } else return dateFormat(mydate);
}

function adeiDateReadableFormat(d, range) {
    if ((range)&&(range <= adei.cfg.subsecond_threshold)) {
	var mydate = new Date(Math.floor(d*1000));
    } else {
	var mydate = new Date(Math.floor(d)*1000);
    }

//    return mydate.toUTCString();
    return mydate.format("isoFullDateTime", true);
}

function adeiDateParse(d) {
    var subsecs = d.indexOf('.');
    if (subsecs < 0) {
	var res = Date.parse(d + " UTC");
	if (isNaN(res)) {
	    res = serverGetResult(adei.GetToolService("parse_date", "timezone=UTC&date=" + d));
	    if (isNaN(res)) return "";
	    return res;
	} 
	return res / 1000;
    }
    
    var dd = d.substr(0,subsecs);
    if (dd.indexOf('.') < 0)  {
	var res = Date.parse(dd + " UTC");
	if (isNaN(res)) {
	    res = serverGetResult(adei.GetToolService("parse_date", "timezone=UTC&date=" + d));
	    if (isNaN(res)) return "";
	    return res;
	}
    } else {
	res = serverGetResult(adei.GetToolService("parse_date", "timezone=UTC&date=" + d));
	if (isNaN(res)) return "";
	return res;
    }
    
    return Math.floor(res / 1000) + '.' + d.substr(subsecs + 1);
}

function adeiMathPreciseSubstract(a, b) {
    var ra, rb;
    var astr = a.toString();
    var bstr = b.toString();

    var pos = astr.indexOf(".");
    if (pos < 0) ra = 0;
    else ra = parseFloat("0." + astr.substr(pos + 1));

    pos = bstr.indexOf(".");
    if (pos < 0) rb = 0;
    else rb = parseFloat("0." + bstr.substr(pos + 1));

    if ((ra)||(rb)) {
	var ia = Math.floor(a);
	var ib = Math.floor(b);

	var r = ra - rb;
	if (r < 0) {
	    var rstr = (r+1).toString();
	    pos = rstr.indexOf('.');
	    return (ia - ib - 1).toString() + rstr.substr(pos);
	} else if (r > 0) {
	    var rstr = r.toString();
	    pos = rstr.indexOf('.');
	    return (ia - ib).toString() + rstr.substr(pos);
	} else return ia - ib;
    } 
    return a - b;	
}

function adeiMathPreciseAdd(a, b) {
    var ra, rb;

    var astr = a.toString();
    var bstr = b.toString();
    
    var pos = astr.indexOf(".");
    if (pos < 0) ra = 0;
    else ra = parseFloat("0." + astr.substr(pos + 1));

    pos = bstr.indexOf(".");
    if (pos < 0) rb = 0;
    else rb = parseFloat("0." + bstr.substr(pos + 1));

    if ((ra)||(rb)) {
	var ia = Math.floor(a);
	var ib = Math.floor(b);

	var r = ra + rb;
	if (r > 1) {
	    var rstr = r.toString();
	    pos = rstr.indexOf('.');
	    return (ia + ib + 1).toString() + rstr.substr(pos);
	} else if (r < 1) {
	    var rstr = r.toString();
	    pos = rstr.indexOf('.');
	    return (ia + ib).toString() + rstr.substr(pos);
	} else return ia + ib + 1;
    } 
    return a + b;	
}

function translate(msg) {
    var str = msg;

    if (!arguments || arguments.length < 2 || !RegExp) {
        return str;
    }
    
    var re = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|b|c|d|u|f|o|s|x|X)(.*)/;
    var a = b = [], numSubstitutions = 0, numMatches = 0;
    while (a = re.exec(str))
    {
        var leftpart = a[1], pPad = a[2], pJustify = a[3], pMinLength = a[4];
        var pPrecision = a[5], pType = a[6], rightPart = a[7];

        numMatches++;
        if (pType == '%')
        {
            subst = '%';
        }
        else
        {
            numSubstitutions++;
            if (numSubstitutions >= arguments.length)
            {
                alert('Error! Not enough function arguments (' + (arguments.length - 1) + ', excluding the string)\nfor the number of substitution parameters in string (' + numSubstitutions + ' so far).');
            }
            var param = arguments[numSubstitutions];
            var pad = '';
            if (pPad && pPad.substr(0,1) == "'") pad = leftpart.substr(1,1);
            else if (pPad) pad = pPad;
            var justifyRight = true;
            if (pJustify && pJustify === "-") justifyRight = false;
            var minLength = -1;
            if (pMinLength) minLength = parseInt(pMinLength);
            var precision = -1;
            if (pPrecision && pType == 'f') precision = parseInt(pPrecision.substring(1));
            var subst = param;
            if (pType == 'b') subst = parseInt(param).toString(2);
            else if (pType == 'c') subst = String.fromCharCode(parseInt(param));
            else if (pType == 'd') subst = parseInt(param) ? parseInt(param) : 0;
            else if (pType == 'u') subst = Math.abs(param);
            else if (pType == 'f') subst = (precision > -1) ? Math.round(parseFloat(param) * Math.pow(10, precision)) / Math.pow(10, precision): parseFloat(param);
            else if (pType == 'o') subst = parseInt(param).toString(8);
            else if (pType == 's') subst = param;
            else if (pType == 'x') subst = ('' + parseInt(param).toString(16)).toLowerCase();
            else if (pType == 'X') subst = ('' + parseInt(param).toString(16)).toUpperCase();
        }
        str = leftpart + subst + rightPart;
    }
    return str;
}

// This code is in the public domain. Feel free to link back to http://jan.moesen.nu/
function sprintf()
{
    if (!arguments || arguments.length < 1 || !RegExp)
    {
        return;
    }
    var str = arguments[0];
    var re = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|b|c|d|u|f|o|s|x|X)(.*)/;
    var a = b = [], numSubstitutions = 0, numMatches = 0;
    while (a = re.exec(str))
    {
        var leftpart = a[1], pPad = a[2], pJustify = a[3], pMinLength = a[4];
        var pPrecision = a[5], pType = a[6], rightPart = a[7];

        //alert(a + '\n' + [a[0], leftpart, pPad, pJustify, pMinLength, pPrecision);

        numMatches++;
        if (pType == '%')
        {
            subst = '%';
        }
        else
        {
            numSubstitutions++;
            if (numSubstitutions >= arguments.length)
            {
                alert('Error! Not enough function arguments (' + (arguments.length - 1) + ', excluding the string)\nfor the number of substitution parameters in string (' + numSubstitutions + ' so far).');
            }
            var param = arguments[numSubstitutions];
            var pad = '';
            if (pPad && pPad.substr(0,1) == "'") pad = leftpart.substr(1,1);
            else if (pPad) pad = pPad;
            var justifyRight = true;
            if (pJustify && pJustify === "-") justifyRight = false;
            var minLength = -1;
            if (pMinLength) minLength = parseInt(pMinLength);
            var precision = -1;
            if (pPrecision && pType == 'f') precision = parseInt(pPrecision.substring(1));
            var subst = param;
            if (pType == 'b') subst = parseInt(param).toString(2);
            else if (pType == 'c') subst = String.fromCharCode(parseInt(param));
            else if (pType == 'd') subst = parseInt(param) ? parseInt(param) : 0;
            else if (pType == 'u') subst = Math.abs(param);
            else if (pType == 'f') subst = (precision > -1) ? Math.round(parseFloat(param) * Math.pow(10, precision)) / Math.pow(10, precision): parseFloat(param);
            else if (pType == 'o') subst = parseInt(param).toString(8);
            else if (pType == 's') subst = param;
            else if (pType == 'x') subst = ('' + parseInt(param).toString(16)).toLowerCase();
            else if (pType == 'X') subst = ('' + parseInt(param).toString(16)).toUpperCase();
        }
        str = leftpart + subst + rightPart;
    }
    return str;
}
