<?php
require("../adei.php");

header("Content-type: application/json");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

try {
    $req = new REQUEST();
    if ($req->CheckData()) {

	$req = $req->CreateDataRequest();

	$draw = $req->CreatePlotter();
	$draw->Create();
	$file = $draw->Save();
	$scale = $draw->GetScaleInfo();
    } else {
	$draw = $req->CreateImageHelper();
	$draw->Create();
	$file = $draw->Save();
	$no_data = true;
    }
} catch(ADEIException $e) {
    $error = $e->getInfo();

    if (($draw)&&($e->getCode() == ADEIException::NO_DATA)) {
	try {
	    $no_data = true;
	    $draw->CreateMessage("Error", $error);
	    $file = $draw->Save();
	    $error = false;
	} catch (ADEIException $ex) {
	    $no_data = false;
	    $ex->logInfo(NULL, $draw);
	}
    } else {
	$e->logInfo(NULL, $draw?$draw:$req);	
    }
}

if ($error) {
    echo json_encode(array("error" => $error));
} else {
    if ($draw) {
	if ($no_data) {
	    echo json_encode(array(
		"module" => "graph",
		"nodata" => true,
		"draw" => 1,
		"image" => $file
	    ));
	} else {
	    echo json_encode(array_merge(array(
		"error" => 0,
		"module" => "graph",
		"draw" => 1,
		"image" => $file
	    ), $scale));
	}
    } else {
	echo json_encode(array(
	    "error" => 0
	));
    }
}


?>